chiark / gitweb /
Parallelise
[post-pizza-notify.git] / onemethod
diff --git a/onemethod b/onemethod
new file mode 100755 (executable)
index 0000000..252c084
--- /dev/null
+++ b/onemethod
@@ -0,0 +1,47 @@
+#!/bin/bash
+set -e
+usage () { cat <<END
+
+usage: ./onemethod METHOD recipientsfile 'message'
+see usage for notify
+
+END
+}
+
+case "$#.$1" in
+3.[^-]*)       ;;
+*)             usage >&2; exit 1 ;;
+esac
+
+onemethod="$1"
+rcpts="$2"
+msg="$3"
+
+exec <"$rcpts"
+line=0
+while read method data; do
+       line=$(( $line+1 ))
+       case "$method" in
+       #*|'')          continue ;;
+       [^a-z]*)        echo >&2 "huh ? $rcpts:$line: $method"; continue ;;
+       "$onemethod")   ;;
+       *)              continue ;;
+       esac
+       log=log-$method-$line.txt
+       exec >$log
+       set +e
+       printf >&2 "."
+       exec 3>&2 2>&1
+       set -x
+       ./"via-$method" "$msg" $data 2>&1
+       rc=$?
+       set +x
+       exec 2>&3 3>&-
+       set -e
+       if [ $rc != 0 ]; then
+               printf >&2 -- "\n$method-FAIL:%s\n" $log
+       else
+               printf >&2 " $method"
+       fi
+done
+exec >&2